









Type mdObject Extends Object
 Public:
 Declare Virtual Function equals(ByRef obj As mdObject) As Boolean
 Declare Virtual Function getClass() As String
 Declare Virtual Function hashCode() As Integer
 Declare Virtual Function toString() As String

 Protected:
 Declare Virtual Function clone() As mdObject
End Type

 Private Function mdObject.equals(ByRef obj As mdObject) As Boolean
 Return @This = @obj
End Function


 Private Function mdObject.getClass() As String
 Dim As ZString Ptr pz = Cast(Any Ptr Ptr Ptr Ptr, @This)[0][-1][1]
 While (*pz)[0] >= Asc("0") AndAlso (*pz)[0] <= Asc("9")
 pz += 1
 Wend
 Return *pz
End Function

 Private Function mdObject.hashCode() As Integer
 Return Cast(Integer, @This)
End Function


 Private Function mdObject.toString() As String
 Return This.getClass() & "@" & @This
End Function


 Private Function mdObject.clone() As mdObject
 Return This
End Function
































Type mdBasicNodeString
 nex As mdBasicNodeString Ptr
 value As String
End Type




Type mdIteratorString Extends mdObject
 Public:
 Declare Constructor ()
 Declare Constructor (ByVal node As mdBasicNodeString Ptr)

 Declare Virtual Function getClass() As String
 Declare Virtual Function hasNext() As Boolean
 Declare Virtual Function nex() As String
 Declare Virtual Sub remove()

 Protected:
 pre As mdBasicNodeString Ptr
 cur As mdBasicNodeString Ptr
End Type

 Private Constructor mdIteratorString()

End Constructor

 Private Constructor mdIteratorString(ByVal node As mdBasicNodeString Ptr)
 This.cur =node
End Constructor

 Private Function mdIteratorString.getClass() As String
 Return UCase("mdIterator(" & $"String" & IIf(Len(""), ", " & "", "") & ")")
End Function

 Private Function mdIteratorString.hasNext() As Boolean
 Return This.cur <> CPtr(Any Ptr, 0)
End Function

 Private Function mdIteratorString.nex() As String
 This.pre =This.cur
 This.cur =This.cur->nex
 Return This.pre->value
End Function

 Private Sub mdIteratorString.remove()
 This.pre->value =This.cur->value
 This.pre->nex =This.cur->nex
 Delete This.cur
 This.cur =This.pre->nex
End Sub




Type mdCollectionString Extends mdObject
 Public:
 Declare Constructor ()
 Declare Constructor (ByRef element As String )
 Declare Constructor (ByRef l As mdCollectionString)
 Declare Virtual Destructor ()

 Declare Virtual Function add(ByRef element As String ) As Boolean
 Declare Virtual Function addAll(ByRef c As mdCollectionString) As Boolean
 Declare Virtual Sub clear()


 Declare Virtual Function contains(ByRef o As String ) As Boolean
 Declare Virtual Function containsAll(ByRef c As mdCollectionString) As Boolean

 Declare Virtual Function equals(ByRef o As mdCollectionString) As Boolean
 Declare Virtual Function getClass() As String
 Declare Virtual Function hashCode() As Integer
 Declare Virtual Function isEmpty() As Boolean
 Declare Virtual Function iterator() As mdIteratorString
 Declare Virtual Function remove(ByVal index As Integer) As String

 Declare Virtual Function remove(ByRef o As String ) As Boolean
 Declare Virtual Function removeAll(ByRef c As mdCollectionString) As Boolean
 Declare Virtual Function retainAll(ByRef c As mdCollectionString) As Boolean

 Declare Virtual Function size() As Integer
 Declare Virtual Function toArray(array() As String ) As Boolean
 Declare Virtual Function toString() As String

 Declare Virtual Operator Cast() As Integer
 Declare Virtual Operator Cast() As String
 Declare Virtual Operator Let(ByRef c As mdCollectionString)

 Declare Virtual Operator [](ByVal index As Integer) ByRef As String

 Protected:
 node As mdBasicNodeString Ptr

End Type

 Private Constructor mdCollectionString()

End Constructor

 Private Constructor mdCollectionString(ByRef element As String )
 This.add(element)
End Constructor

 Private Constructor mdCollectionString(ByRef l As mdCollectionString)
 This.addAll(l)
End Constructor

 Private Destructor mdCollectionString()
 This.clear()
End Destructor

 Private Function mdCollectionString.add(ByRef element As String ) As Boolean
 Dim As mdBasicNodeString Ptr currentNode =This.node, prevNode
 While currentNode <> CPtr(Any Ptr, 0)
 prevNode =currentNode
 currentNode =currentNode->nex
 Wend

 currentNode =New mdBasicNodeString
 currentNode->value =element
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =currentNode
 EndIf
 If This.node = CPtr(Any Ptr, 0) Then
 This.node =currentNode
 EndIf
 Return TRUE
End Function

 Private Function mdCollectionString.addAll(ByRef c As mdCollectionString) As Boolean
 If c.isEmpty() Then
 Return FALSE
 EndIf

 Dim As String temp
 Scope

 Dim As mdIteratorString tempmdIteratorString =c.iterator()
 While tempmdIteratorString.hasNext()
 temp =tempmdIteratorString.nex()
 This.add(temp)
 Wend : End Scope
 Return TRUE
End Function

 Private Sub mdCollectionString.clear()
 Dim As mdBasicNodeString Ptr currentNode =This.node, nextNode
 While currentNode <> CPtr(Any Ptr, 0)
 nextNode =currentNode->nex
 Delete currentNode
 currentNode =nextNode
 Wend
 This.node = CPtr(Any Ptr, 0)
End Sub











 Private Function mdCollectionString.contains(ByRef o As String ) As Boolean
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If currentNode->value =o Then
 Return TRUE
 EndIf
 currentNode =currentNode->nex
 Wend
 Return FALSE
End Function

 Private Function mdCollectionString.containsAll(ByRef c As mdCollectionString) As Boolean
 Dim As String temp
 Scope

 Dim As mdIteratorString tempmdIteratorString =c.iterator()
 While tempmdIteratorString.hasNext()
 temp =tempmdIteratorString.nex()
 If This.contains(temp) =FALSE Then
 Return FALSE
 EndIf
 Wend : End Scope
 Return TRUE
End Function

 Private Function mdCollectionString.equals(ByRef o As mdCollectionString) As Boolean
 Return This.toString() =o.toString()
End Function

 Private Function mdCollectionString.getClass() As String
 Return UCase("mdCollection(" & $"String" & IIf(Len(""), ", " & "", "") & ")")
End Function

 Private Function mdCollectionString.hashCode() As Integer
 Dim As Integer hash =1
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 hash =31 * hash + IIf(currentNode = CPtr(Any Ptr, 0), 0, Cast(UInteger, currentNode) \ This.size())
 currentNode =currentNode->nex
 Wend
 Return hash
End Function

 Private Function mdCollectionString.isEmpty() As Boolean
 Return This.size() =0
End Function

 Private Function mdCollectionString.iterator() As mdIteratorString
 Dim As mdIteratorString newIterator =This.node
 Return newIterator
End Function

 Private Function mdCollectionString.remove(ByVal index As Integer) As String
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node, nextNode, prevNode
 While currentNode <> CPtr(Any Ptr, 0)
 If i =index Then
 Dim As String value =currentNode->value
 nextNode =currentNode->nex
 If currentNode =This.node Then
 This.node =nextNode
 EndIf
 Delete currentNode
 currentNode =nextNode
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =currentNode
 EndIf
 Return value
 EndIf

 i +=1
 prevNode =currentNode
 If currentNode <> CPtr(Any Ptr, 0) Then
 currentNode =currentNode->nex
 EndIf
 Wend
 Dim As String tempRet
 Return tempRet
End Function

 Private Function mdCollectionString.remove(ByRef o As String ) As Boolean
 Dim As mdBasicNodeString Ptr currentNode =This.node, nextNode, prevNode
 While currentNode <> CPtr(Any Ptr, 0)
 If currentNode->value =o Then
 nextNode =currentNode->nex
 If currentNode =This.node Then
 This.node =nextNode
 EndIf
 Delete currentNode
 currentNode =nextNode
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =currentNode
 EndIf
 Return TRUE
 EndIf
 prevNode =currentNode
 If currentNode <> CPtr(Any Ptr, 0) Then
 currentNode =currentNode->nex
 EndIf
 Wend
 Return FALSE
End Function

 Private Function mdCollectionString.removeAll(ByRef c As mdCollectionString) As Boolean
 Dim As Integer cSize =c.size()

 If cSize =0 OrElse This.size() =0 Then
 Return FALSE
 EndIf

 Dim As String temp
 Scope

 Dim As mdIteratorString tempmdIteratorString =c.iterator()
 While tempmdIteratorString.hasNext()
 temp =tempmdIteratorString.nex()
 If This.contains(temp) Then
 This.remove(temp)
 EndIf
 Wend : End Scope
 Return TRUE
End Function

 Private Function mdCollectionString.retainAll(ByRef c As mdCollectionString) As Boolean
 Dim As Integer thisSize =This.size()

 If thisSize =0 OrElse c.size() =0 Then
 Return FALSE
 EndIf
 Dim As mdBasicNodeString Ptr currentNode =This.node, nextNode, prevNode
 While currentNode <> CPtr(Any Ptr, 0)
 nextNode =currentNode->nex
 If c.contains(currentNode->value) =FALSE Then
 If currentNode =This.node Then
 This.node =nextNode
 EndIf
 Delete currentNode
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =nextNode
 EndIf
 If currentNode =This.node Then
 This.node =nextNode
 EndIf
 Else
 prevNode =currentNode
 EndIf
 currentNode =nextNode
 Wend
 Return TRUE
End Function







 Private Function mdCollectionString.size() As Integer
 Dim As Integer count =0
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 count +=1
 currentNode =currentNode->nex
 Wend
 Return count
End Function

 Private Function mdCollectionString.toArray(array() As String ) As Boolean
 Dim As Integer thisSize =This.size(), i =0
 If thisSize =0 Then
 Return FALSE
 EndIf

 ReDim array(0 To thisSize -1)
 If @array(0) = CPtr(Any Ptr, 0) Then
 Return FALSE
 EndIf

 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 array(i) =currentNode->value
 i +=1
 currentNode =currentNode->nex
 Wend
 Return TRUE
End Function

 Private Function mdCollectionString.toString() As String
 Dim As String ret ="["
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 ret &=Str(currentNode->value)
 currentNode =currentNode->nex
 If currentNode <> CPtr(Any Ptr, 0) Then
 ret &=", "
 EndIf
 Wend
 ret &="]"
 Return ret
End Function

 Private Operator mdCollectionString.Cast() As Integer
 Return This.hashCode()
End Operator

 Private Operator mdCollectionString.Cast() As String
 Return This.toString()
End Operator

 Private Operator mdCollectionString.Let(ByRef c As mdCollectionString)
 This.clear()
 This.addAll(c)
End Operator

 Private Operator mdCollectionString.[](ByVal index As Integer) ByRef As String
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If i =index Then
 Return currentNode->value
 EndIf

 i +=1
 currentNode =currentNode->nex
 Wend
 Dim As mdBasicNodeString Ptr tempRet
 Return tempRet->value
End Operator

 Private Operator =(ByRef lhs As mdCollectionString, ByRef rhs As mdCollectionString) As Boolean
 Return lhs.toString() =rhs.toString()
End Operator




Type mdListString Extends mdCollectionString
 Public:
 Declare Constructor ()
 Declare Constructor (ByRef element As String )
 Declare Constructor (ByRef l As mdCollectionString)

 Declare Virtual Function add(ByRef element As String ) As Boolean
 Declare Virtual Function add(ByVal index As Integer, ByRef element As String ) As Boolean
 Declare Virtual Function addAll(ByRef c As mdCollectionString) As Boolean
 Declare Virtual Function addAll(ByVal index As Integer, ByRef c As mdCollectionString) As Boolean
 Declare Virtual Function get(ByVal index As Integer) As String
 Declare Virtual Function getClass() As String

 Declare Virtual Function indexOf(ByRef o As String ) As Integer

 Declare Virtual Function lastIndexOf(ByRef o As String ) As Integer


 Declare Virtual Function set(ByVal index As Integer, ByRef element As String ) As String
 Declare Virtual Function subList(ByVal fromIndex As Integer, ByVal toIndex As Integer) As mdListString

 Declare Virtual Operator Cast() As Integer
 Declare Virtual Operator Cast() As String
 Declare Virtual Operator Let(ByRef c As mdCollectionString)

 Declare Virtual Operator [](ByVal index As Integer) ByRef As String
End Type

 Private Constructor mdListString()

End Constructor

 Private Constructor mdListString(ByRef element As String )
 This.add(element)
End Constructor

 Private Constructor mdListString(ByRef l As mdCollectionString)
 This.addAll(l)
End Constructor

 Private Function mdListString.add(ByRef element As String ) As Boolean
 Dim As mdBasicNodeString Ptr currentNode =This.node, prevNode
 While currentNode <> CPtr(Any Ptr, 0)
 prevNode =currentNode
 currentNode =currentNode->nex
 Wend

 currentNode =New mdBasicNodeString
 If currentNode = CPtr(Any Ptr, 0) Then
 Return FALSE
 Else
 currentNode->value =element
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =currentNode
 EndIf
 If This.node = CPtr(Any Ptr, 0) Then
 This.node =currentNode
 EndIf
 Return TRUE
 EndIf
End Function

 Private Function mdListString.add(ByVal index As Integer, ByRef element As String ) As Boolean
 If index =This.size() Then
 Return This.add(element)
 Else
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node, nextNode, prevNode, newNode
 While currentNode <> CPtr(Any Ptr, 0)
 If i =index Then
 nextNode =currentNode
 newNode =New mdBasicNodeString
 newNode->value =element
 newNode->nex =currentNode
 If prevNode <> CPtr(Any Ptr, 0) Then
 prevNode->nex =newNode
 EndIf
 If This.node =currentNode Then
 This.node =newNode
 EndIf
 Return TRUE
 EndIf

 i +=1
 prevNode =currentNode
 currentNode =currentNode->nex
 Wend

 Return FALSE
 EndIf
End Function

 Private Function mdListString.addAll(ByRef c As mdCollectionString) As Boolean
 If c.isEmpty() Then
 Return FALSE
 EndIf

 Dim As String temp
 Scope

 Dim As mdIteratorString tempmdIteratorString =c.iterator()
 While tempmdIteratorString.hasNext()
 temp =tempmdIteratorString.nex()
 This.add(temp)
 Wend : End Scope
 Return TRUE
End Function

 Private Function mdListString.addAll(ByVal index As Integer, ByRef c As mdCollectionString) As Boolean
 If index <0 OrElse This.size() <index Then
 Return FALSE
 EndIf

 If c.isEmpty() Then
 Return FALSE
 EndIf

 Dim As Integer i
 Dim As String temp
 Scope

 Dim As mdIteratorString tempmdIteratorString =c.iterator()
 While tempmdIteratorString.hasNext()
 temp =tempmdIteratorString.nex()
 This.add(index + i, temp)
 i +=1
 Wend : End Scope
 Return TRUE
End Function

 Private Function mdListString.get(ByVal index As Integer) As String
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If i =index Then
 Return currentNode->value
 EndIf

 i +=1
 currentNode =currentNode->nex
 Wend
 Dim As String tempRet
 Return tempRet
End Function

 Private Function mdListString.getClass() As String
 Return UCase("mdList(" & $"String" & IIf(Len(""), ", " & "", "") & ")")
End Function

 Private Function mdListString.indexOf(ByRef o As String ) As Integer
 Dim As Integer i =-1, retIndex =-1
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 i +=1
 If currentNode->value =o Then
 retIndex =i
 Exit While
 EndIf
 currentNode =currentNode->nex
 Wend
 Return retIndex
End Function

 Private Function mdListString.lastIndexOf(ByRef o As String ) As Integer
 Dim As Integer i =0, retIndex =-1
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If currentNode->value =o Then
 retIndex =i
 EndIf
 i +=1
 currentNode =currentNode->nex
 Wend
 Return retIndex
End Function

 Private Function mdListString.set(ByVal index As Integer, ByRef element As String ) As String
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode->nex <> CPtr(Any Ptr, 0)
 If i =index Then
 Dim As String value =currentNode->value
 currentNode->value =element
 Return value
 EndIf

 i +=1
 currentNode =currentNode->nex
 Wend
 Dim As String tempRet
 Return tempRet
End Function

 Private Function mdListString.subList(ByVal fromIndex As Integer, ByVal toIndex As Integer) As mdListString
 Dim As Integer i =0
 Dim As mdListString newmdList
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If i >= fromIndex AndAlso i <= toIndex Then
 newmdList.add(currentNode->value)
 EndIf
 i +=1
 currentNode =currentNode->nex
 Wend
 Return newmdList
End Function

 Private Operator mdListString.Cast() As Integer
 Return This.hashCode()
End Operator

 Private Operator mdListString.Cast() As String
 Return This.toString()
End Operator

 Private Operator mdListString.Let(ByRef c As mdCollectionString)
 This.clear()
 This.addAll(c)
End Operator

 Private Operator mdListString.[](ByVal index As Integer) ByRef As String
 Dim As Integer i =0
 Dim As mdBasicNodeString Ptr currentNode =This.node
 While currentNode <> CPtr(Any Ptr, 0)
 If i =index Then
 Return currentNode->value
 EndIf

 i +=1
 currentNode =currentNode->nex
 Wend
 Dim As mdBasicNodeString Ptr tempRet
 Return tempRet->value
End Operator

 Private Operator =(ByRef lhs As mdListString, ByRef rhs As mdListString) As Boolean
 Return lhs.toString() =rhs.toString()
End Operator



Type mdThreadedLong Extends mdObject
 Public:
 Declare Constructor ()
 Declare Constructor (ByVal sharedMutex As Any Ptr)
 Declare Destructor ()

 Declare Virtual Operator Cast() As String
 Declare Virtual Operator Cast() ByRef As Long
 Declare Virtual Operator Let(ByRef value As Long )

 Declare Virtual Function getValue() ByRef As Long
 Declare Virtual Sub setValue(ByRef value As Long )

 Declare Virtual Function getMutex() As Any Ptr

 Protected:
 Declare Virtual Sub setMutex(ByVal mutex As Any Ptr)

 Private:
 As Long value
 As Any Ptr mutex
End Type

 Private Constructor mdThreadedLong()
 This.mutex =MutexCreate()
End Constructor

 Private Constructor mdThreadedLong(ByVal sharedMutex As Any Ptr)
 This.setMutex(sharedMutex)
End Constructor

 Private Destructor mdThreadedLong()
 MutexDestroy(This.mutex)
 This.mutex = CPtr(Any Ptr, 0)
End Destructor

 Private Operator mdThreadedLong.Cast() As String
 Return Str(This.value)
 End Operator

 Private Operator mdThreadedLong.Cast() ByRef As Long
 Return This.getValue()
 End Operator

 Private Operator mdThreadedLong.Let(ByRef value As Long )
 This.setValue(value)
End Operator

 Private Function mdThreadedLong.getValue() ByRef As Long
 MutexLock(This.mutex)
 Dim ByRef As Long localCopy =This.value
 MutexUnLock(This.mutex)

 Return localCopy
End Function

 Private Sub mdThreadedLong.setValue(ByRef value As Long )
 MutexLock(This.mutex)
 This.value =value
 MutexUnLock(This.mutex)
End Sub

 Private Function mdThreadedLong.getMutex() As Any Ptr
 Return This.mutex
End Function

 Private Sub mdThreadedLong.setMutex(ByVal mutex As Any Ptr)
 This.mutex =mutex
End Sub

 Private Operator =(ByRef lhs As mdThreadedLong, ByRef rhs As mdThreadedLong) As Boolean
 Return lhs.toString() =rhs.toString()
End Operator



Type mdThreadedString Extends mdObject
 Public:
 Declare Constructor ()
 Declare Constructor (ByVal sharedMutex As Any Ptr)
 Declare Destructor ()

 Declare Virtual Operator Cast() ByRef As String
 Declare Virtual Operator Let(ByRef value As String )

 Declare Virtual Function getValue() ByRef As String
 Declare Virtual Sub setValue(ByRef value As String )

 Declare Virtual Function getMutex() As Any Ptr

 Protected:
 Declare Virtual Sub setMutex(ByVal mutex As Any Ptr)

 Private:
 As String value
 As Any Ptr mutex
End Type

 Private Constructor mdThreadedString()
 This.mutex =MutexCreate()
End Constructor

 Private Constructor mdThreadedString(ByVal sharedMutex As Any Ptr)
 This.setMutex(sharedMutex)
End Constructor

 Private Destructor mdThreadedString()
 MutexDestroy(This.mutex)
 This.mutex = CPtr(Any Ptr, 0)
End Destructor


 Private Operator mdThreadedString.Cast() ByRef As String
 Return This.getValue()
 End Operator

 Private Operator mdThreadedString.Let(ByRef value As String )
 This.setValue(value)
End Operator

 Private Function mdThreadedString.getValue() ByRef As String
 MutexLock(This.mutex)
 Dim ByRef As String localCopy =This.value
 MutexUnLock(This.mutex)

 Return localCopy
End Function

 Private Sub mdThreadedString.setValue(ByRef value As String )
 MutexLock(This.mutex)
 This.value =value
 MutexUnLock(This.mutex)
End Sub

 Private Function mdThreadedString.getMutex() As Any Ptr
 Return This.mutex
End Function

 Private Sub mdThreadedString.setMutex(ByVal mutex As Any Ptr)
 This.mutex =mutex
End Sub

 Private Operator =(ByRef lhs As mdThreadedString, ByRef rhs As mdThreadedString) As Boolean
 Return lhs.toString() =rhs.toString()
End Operator



Type mdThreadedmdListString Extends mdObject
 Public:
 Declare Constructor ()
 Declare Constructor (ByVal sharedMutex As Any Ptr)
 Declare Destructor ()

 Declare Virtual Operator Cast() As String
 Declare Virtual Operator Cast() ByRef As mdListString
 Declare Virtual Operator Let(ByRef value As mdListString )

 Declare Virtual Function getValue() ByRef As mdListString
 Declare Virtual Sub setValue(ByRef value As mdListString )

 Declare Virtual Function getMutex() As Any Ptr

 Protected:
 Declare Virtual Sub setMutex(ByVal mutex As Any Ptr)

 Private:
 As mdListString value
 As Any Ptr mutex
End Type

 Private Constructor mdThreadedmdListString()
 This.mutex =MutexCreate()
End Constructor

 Private Constructor mdThreadedmdListString(ByVal sharedMutex As Any Ptr)
 This.setMutex(sharedMutex)
End Constructor

 Private Destructor mdThreadedmdListString()
 MutexDestroy(This.mutex)
 This.mutex = CPtr(Any Ptr, 0)
End Destructor

 Private Operator mdThreadedmdListString.Cast() As String
 Return Str(This.value)
 End Operator

 Private Operator mdThreadedmdListString.Cast() ByRef As mdListString
 Return This.getValue()
 End Operator

 Private Operator mdThreadedmdListString.Let(ByRef value As mdListString )
 This.setValue(value)
End Operator

 Private Function mdThreadedmdListString.getValue() ByRef As mdListString
 MutexLock(This.mutex)
 Dim ByRef As mdListString localCopy =This.value
 MutexUnLock(This.mutex)

 Return localCopy
End Function

 Private Sub mdThreadedmdListString.setValue(ByRef value As mdListString )
 MutexLock(This.mutex)
 This.value =value
 MutexUnLock(This.mutex)
End Sub

 Private Function mdThreadedmdListString.getMutex() As Any Ptr
 Return This.mutex
End Function

 Private Sub mdThreadedmdListString.setMutex(ByVal mutex As Any Ptr)
 This.mutex =mutex
End Sub

 Private Operator =(ByRef lhs As mdThreadedmdListString, ByRef rhs As mdThreadedmdListString) As Boolean
 Return lhs.toString() =rhs.toString()
End Operator


Type TestCaseThreaded Extends Object
 As mdThreadedLong longValue
 As mdThreadedString stringValue
 As mdThreadedmdListString listValue
End Type

Type TestCaseUnThreaded Extends Object
 As Long longValue
 As String stringValue
 As mdListString listValue
End Type


Dim Shared As TestCaseUnThreaded clazz
Dim As Any Ptr thread
Dim As Integer count



Sub myThread(ByVal Parameter as Any Ptr)
 Do
 clazz.stringValue.setValue(Str(clazz.listValue.getValue().size()))
 If clazz.listValue.getValue().isEmpty() Then
 clazz.listValue.getValue().remove(0)
 EndIf
 Sleep 100, 1
 If clazz.longValue.getValue() = 1 Thenabbrechen wenn 1
 Exit Do
