'mdThreaded - by MOD

'no Java representation


#Include Once "md/lang/mdObject.bi"

#Define mdThreadedPtr(E, P) mdThreaded##E##P
#Define mdThreaded(E, P...) mdThreadedPtr(E, P)


#Ifndef mdThreaded_Get
	#Macro mdThreaded_Get(object_, method, ret)
		MutexLock(object_.getMutex())
			ret = object_##method
		MutexUnLock(object_.getMutex())
	#EndMacro
#EndIf


#Macro mdThreadedDeclarePtr(E, P)

#Ifndef mdThreaded##E##P
'#Define __MDTHREADED_BI__

Type mdThreaded##E##P Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByVal sharedMutex As Any Ptr)
	Declare Destructor ()
	
	#If Not (TypeOf(E) = "STRING" AndAlso #P = "")
		Declare Virtual Operator Cast() As String
	#EndIf
	#If TypeOf(E) <> "STRING" OrElse (TypeOf(E) = "STRING" AndAlso #P = "")
		Declare Virtual Operator Cast() ByRef As E P
	#EndIf
	Declare Virtual Operator Let(ByRef value As E P)
	
	Declare Virtual Function getValue() ByRef As E P
	Declare Virtual Sub setValue(ByRef value As E P)
	
	Declare Virtual Function getMutex() As Any Ptr
	
	Protected:
	Declare Virtual Sub setMutex(ByVal mutex As Any Ptr)
	
	Private:
	As E P value
	As Any Ptr mutex
End Type

MODULE_SCOPE Constructor mdThreaded##E##P()
	This.mutex = MutexCreate()
End Constructor

MODULE_SCOPE Constructor mdThreaded##E##P(ByVal sharedMutex As Any Ptr)
	This.setMutex(sharedMutex) 'use existing mutex
End Constructor

MODULE_SCOPE Destructor mdThreaded##E##P()
	MutexDestroy(This.mutex)
	This.mutex = NULL
End Destructor

#If Not (TypeOf(E) = "STRING" AndAlso #P = "")
	MODULE_SCOPE Operator mdThreaded##E##P.Cast() As String
		Return Str(This.value)
	End Operator
#EndIf

#If TypeOf(E) <> "STRING" OrElse (TypeOf(E) = "STRING" AndAlso #P = "")
	MODULE_SCOPE Operator mdThreaded##E##P.Cast() ByRef As E P
		Return This.getValue()
	End Operator
#EndIf

MODULE_SCOPE Operator mdThreaded##E##P.Let(ByRef value As E P)
	This.setValue(value)
End Operator

MODULE_SCOPE Function mdThreaded##E##P.getValue() ByRef As E P
	MutexLock(This.mutex)
		Dim ByRef As E P localCopy = This.value
	MutexUnLock(This.mutex)
	
	Return localCopy
End Function

MODULE_SCOPE Sub mdThreaded##E##P.setValue(ByRef value As E P)
	MutexLock(This.mutex)
		This.value = value
	MutexUnLock(This.mutex)
End Sub

MODULE_SCOPE Function mdThreaded##E##P.getMutex() As Any Ptr
	Return This.mutex
End Function

MODULE_SCOPE Sub mdThreaded##E##P.setMutex(ByVal mutex As Any Ptr)
	This.mutex = mutex
End Sub

MODULE_SCOPE Operator = (ByRef lhs As mdThreaded##E##P, ByRef rhs As mdThreaded##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDTHREADED_BI__

#EndMacro

#Define mdThreadedDeclare(E, P...) mdThreadedDeclarePtr(E, P)
