'mdBoolean - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/lang/Boolean.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/lang/mdString.bi"

#Ifndef __MDBOOLEAN_BI__
#Define __MDBOOLEAN_BI__

Type mdBoolean Extends mdObject
	Public:
	As Boolean getFALSE = FALSE
	As Boolean getTRUE = TRUE
	
	Declare Constructor (ByVal value As Boolean)
	Declare Constructor (ByVal s As ZString Ptr)
	Declare Constructor (ByRef s As mdString)
	Declare Destructor ()
	
	Declare Function booleanValue() As Boolean
	Declare Function compareTo(ByRef b As mdBoolean) As Integer
	'Declare Function equals(ByRef obj As mdObject) As Boolean
	Declare Function equals(ByRef obj As mdBoolean) As Boolean
	Declare Static Function getBoolean(ByVal name_ As ZString Ptr) As Boolean
	Declare Static Function getBoolean(ByRef name_ As mdString) As Boolean
	Declare Function hashCode() As Integer
	Declare Static Function parseBoolean(ByVal s As ZString Ptr) As Boolean
	Declare Static Function parseBoolean(ByRef s As mdString) As Boolean
	Declare Function toString() As String
	Declare Static Function toString(ByVal b As Boolean) As String
	Declare Function tomdString() As mdString
	Declare Static Function tomdString(ByVal b As Boolean) As mdString
	Declare Static Function valueOf(ByVal b As Boolean) As mdBoolean
	Declare Static Function valueOf(ByVal s As ZString Ptr) As mdBoolean
	Declare Static Function valueOf(ByRef s As mdString) As mdBoolean
	
	Declare Operator Cast() As Boolean
	Declare Operator Cast() As String
	Declare Operator Let(ByVal value As Boolean)
	Declare Operator Let(ByRef value As mdBoolean)
	
	Private:
	value As Boolean = FALSE
End Type

MODULE_SCOPE Constructor mdBoolean(ByVal value As Boolean)
	This.value = value
End Constructor

MODULE_SCOPE Constructor mdBoolean(ByVal s As ZString Ptr)
	This.value = ValInt(*s)
End Constructor

MODULE_SCOPE Constructor mdBoolean(ByRef s As mdString)
	This.value = ValInt(*s.toCharArray())
End Constructor

MODULE_SCOPE Destructor mdBoolean()
	
End Destructor

MODULE_SCOPE Function mdBoolean.booleanValue() As Boolean
	Return This.value
End Function

MODULE_SCOPE Function mdBoolean.compareTo(ByRef b As mdBoolean) As Integer
	If This.value = b.booleanValue() Then
		Return 0
	ElseIf This.value = TRUE AndAlso b.booleanValue() = FALSE Then
		Return 1
	ElseIf This.value = FALSE AndAlso b.booleanValue() = TRUE Then
		Return -1
	EndIf
End Function

'MODULE_SCOPE Function mdBoolean.equals(ByRef obj As mdObject) As Boolean

MODULE_SCOPE Function mdBoolean.equals(ByRef obj As mdBoolean) As Boolean
	Return This.value = obj.booleanValue()
End Function

MODULE_SCOPE Function mdBoolean.getBoolean(ByVal name_ As ZString Ptr) As Boolean
	Return LCase(*name_) = "true"
End Function

MODULE_SCOPE Function mdBoolean.getBoolean(ByRef name_ As mdString) As Boolean
	Return LCase(*name_.toCharArray()) = "true"
End Function

MODULE_SCOPE Function mdBoolean.hashCode() As Integer
	If This.value = FALSE Then
		Return 1237
	Else
		Return 1231
	EndIf
End Function

MODULE_SCOPE Function mdBoolean.parseBoolean(ByVal s As ZString Ptr) As Boolean
	Return LCase(*s) = "true"
End Function

MODULE_SCOPE Function mdBoolean.parseBoolean(ByRef s As mdString) As Boolean
	Return LCase(*s.toCharArray()) = "true"
End Function

MODULE_SCOPE Function mdBoolean.toString() As String
	If This.value = FALSE Then
		Return "false"
	Else
		Return "true"
	EndIf
End Function

MODULE_SCOPE Function mdBoolean.toString(ByVal b As Boolean) As String
	If b = FALSE Then
		Return "false"
	Else
		Return "true"
	EndIf
End Function

MODULE_SCOPE Function mdBoolean.tomdString() As mdString
	Dim As mdString newString
	If This.value = FALSE Then
		newString = "false"
	Else
		newString = "true"
	EndIf
	Return newString
End Function

MODULE_SCOPE Function mdBoolean.tomdString(ByVal b As Boolean) As mdString
	Dim As mdString newString
	If b = FALSE Then
		newString = "false"
	Else
		newString = "true"
	EndIf
	Return newString
End Function

MODULE_SCOPE Function mdBoolean.valueOf(ByVal b As Boolean) As mdBoolean
	Dim As mdBoolean Ptr newBoolean = New mdBoolean(b)
	Return *newBoolean
End Function

MODULE_SCOPE Function mdBoolean.valueOf(ByVal s As ZString Ptr) As mdBoolean
	Dim As mdBoolean Ptr newBoolean = New mdBoolean(s)
	Return *newBoolean
End Function

MODULE_SCOPE Function mdBoolean.valueOf(ByRef s As mdString) As mdBoolean
	Dim As mdBoolean Ptr newBoolean = New mdBoolean(s)
	Return *newBoolean
End Function

MODULE_SCOPE Operator mdBoolean.Cast() As Boolean
	Return This.booleanValue()
End Operator

MODULE_SCOPE Operator mdBoolean.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdBoolean.Let(ByVal value As Boolean)
	This.value = value
End Operator

MODULE_SCOPE Operator mdBoolean.Let(ByRef value As mdBoolean)
	This.value = value.booleanValue()
End Operator

MODULE_SCOPE Operator = (ByRef lhs As mdBoolean, ByRef rhs As mdBoolean) As Boolean
	Return lhs.equals(rhs)
End Operator

#EndIf '__MDBOOLEAN_BI__
